/* Javascript output generated by archetype 1.3.5 */

/* Utils functions */

export const mk_int    = v  => {return { "int" : v.toString() }}
export const mk_string = v  => {return { "string" : v }}
export const mk_bytes  = v  => {return { "bytes" : v.toString() }}
export const mk_some   = v  => {return { "prim": "Some", "args": [ v ] }}
export const mk_none   = () => {return { "prim": "None" }}
export const mk_rational = (n, d) => {return {  "prim": "Pair", "args": [ {  "int": n.toString()  }, {  "int": d.toString()  } ] }}

/* Code */

export const code =
  [  {  "prim": "storage",
        "args": [
          {  "prim": "pair",
             "args": [
               {  "prim": "address",
                  "annots": [
                    "%a_contractToken"
                  ]
               },
               {  "prim": "pair",
                  "args": [
                    {  "prim": "nat",
                       "annots": [
                         "%a_token_id"
                       ]
                    },
                    {  "prim": "pair",
                       "args": [
                         {  "prim": "nat",
                            "annots": [
                              "%a_quantity"
                            ]
                         },
                         {  "prim": "pair",
                            "args": [
                              {  "prim": "address",
                                 "annots": [
                                   "%a_debtor"
                                 ]
                              },
                              {  "prim": "pair",
                                 "args": [
                                   {  "prim": "address",
                                      "annots": [
                                        "%a_creditor"
                                      ]
                                   },
                                   {  "prim": "pair",
                                      "args": [
                                        {  "prim": "address",
                                           "annots": [
                                             "%b_contractToken"
                                           ]
                                        },
                                        {  "prim": "pair",
                                           "args": [
                                             {  "prim": "nat",
                                                "annots": [
                                                  "%b_token_id"
                                                ]
                                             },
                                             {  "prim": "pair",
                                                "args": [
                                                  {  "prim": "nat",
                                                     "annots": [
                                                       "%b_quantity"
                                                     ]
                                                  },
                                                  {  "prim": "pair",
                                                     "args": [
                                                       {  "prim": "address",
                                                          "annots": [
                                                            "%b_debtor"
                                                          ]
                                                       },
                                                       {  "prim": "pair",
                                                          "args": [
                                                            {  "prim": "address",
                                                               "annots": [
                                                                 "%b_creditor"
                                                               ]
                                                            },
                                                            {  "prim": "int",
                                                               "annots": [
                                                                 "%_state"
                                                               ]
                                                            }
                                                          ]
                                                       }
                                                     ]
                                                  }
                                                ]
                                             }
                                           ]
                                        }
                                      ]
                                   }
                                 ]
                              }
                            ]
                         }
                       ]
                    }
                  ]
               }
             ]
          }
        ]
  },
  {  "prim": "parameter",
     "args": [
       {  "prim": "unit",
          "annots": [
            "%exchange"
          ]
       }
     ]
  },
  {  "prim": "code",
     "args": [
       [  {  "prim": "NIL",
             "args": [
               {  "prim": "operation"  }
             ]
       },
       {  "prim": "DIG",
          "args": [
            {  "int": "1"  }
          ]
       },
       {  "prim": "UNPAIR"  },
       {  "prim": "DIP",
          "args": [
            {  "int": "1"  },
            [  {  "prim": "UNPAIR",
                  "args": [
                    {  "int": "11"  }
                  ]
            }  ]
          ]
       },
       {  "prim": "DROP",
          "args": [
            {  "int": "1"  }
          ]
       },
       {  "prim": "DUP",
          "args": [
            {  "int": "11"  }
          ]
       },
       {  "prim": "DUP"  },
       {  "prim": "PUSH",
          "args": [
            {  "prim": "int"  },
            {  "int": "0"  }
          ]
       },
       {  "prim": "COMPARE"  },
       {  "prim": "EQ"  },
       {  "prim": "IF",
          "args": [
            [  {  "prim": "DUP",
                  "args": [
                    {  "int": "4"  }
                  ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "4"  }
               ]
            },
            {  "prim": "PAIR"  },
            {  "prim": "DUP",
               "args": [
                 {  "int": "7"  }
               ]
            },
            {  "prim": "PAIR"  },
            {  "prim": "NIL",
               "args": [
                 {  "prim": "pair",
                    "args": [
                      {  "prim": "address",
                         "annots": [
                           "%to_"
                         ]
                      },
                      {  "prim": "pair",
                         "args": [
                           {  "prim": "nat",
                              "annots": [
                                "%token_id"
                              ]
                           },
                           {  "prim": "nat",
                              "annots": [
                                "%amount"
                              ]
                           }
                         ]
                      }
                    ]
                 }
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "2"  }
               ]
            },
            {  "prim": "CONS"  },
            {  "prim": "DUP",
               "args": [
                 {  "int": "7"  }
               ]
            },
            {  "prim": "PAIR"  },
            {  "prim": "DUP",
               "args": [
                 {  "int": "11"  }
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "11"  }
               ]
            },
            {  "prim": "PAIR"  },
            {  "prim": "DUP",
               "args": [
                 {  "int": "14"  }
               ]
            },
            {  "prim": "PAIR"  },
            {  "prim": "NIL",
               "args": [
                 {  "prim": "pair",
                    "args": [
                      {  "prim": "address",
                         "annots": [
                           "%to_"
                         ]
                      },
                      {  "prim": "pair",
                         "args": [
                           {  "prim": "nat",
                              "annots": [
                                "%token_id"
                              ]
                           },
                           {  "prim": "nat",
                              "annots": [
                                "%amount"
                              ]
                           }
                         ]
                      }
                    ]
                 }
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "2"  }
               ]
            },
            {  "prim": "CONS"  },
            {  "prim": "DUP",
               "args": [
                 {  "int": "14"  }
               ]
            },
            {  "prim": "PAIR"  },
            {  "prim": "NIL",
               "args": [
                 {  "prim": "operation"  }
               ]
            },
            {  "prim": "NIL",
               "args": [
                 {  "prim": "operation"  }
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "19"  }
               ]
            },
            {  "prim": "ITER",
               "args": [
                 [  {  "prim": "CONS"  }  ]
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "8"  }
               ]
            },
            {  "prim": "CONTRACT",
               "args": [
                 {  "prim": "list",
                    "args": [
                      {  "prim": "pair",
                         "args": [
                           {  "prim": "address"  },
                           {  "prim": "list",
                              "args": [
                                {  "prim": "pair",
                                   "args": [
                                     {  "prim": "address"  },
                                     {  "prim": "pair",
                                        "args": [
                                          {  "prim": "nat"  },
                                          {  "prim": "nat"  }
                                        ]
                                     }
                                   ]
                                }
                              ]
                           }
                         ]
                      }
                    ]
                 }
               ]
               ,
               "annots": [
                 "%transfer"
               ]
            },
            {  "prim": "IF_NONE",
               "args": [
                 [  {  "prim": "PUSH",
                       "args": [
                         {  "prim": "string"  },
                         {  "string": "transfer"  }
                       ]
                 },
                 {  "prim": "PUSH",
                    "args": [
                      {  "prim": "string"  },
                      {  "string": "ENTRY_NOT_FOUND"  }
                    ]
                 },
                 {  "prim": "PAIR"  },
                 {  "prim": "FAILWITH"  }  ],
                 [    ]
               ]
            },
            {  "prim": "PUSH",
               "args": [
                 {  "prim": "mutez"  },
                 {  "int": "0"  }
               ]
            },
            {  "prim": "NIL",
               "args": [
                 {  "prim": "pair",
                    "args": [
                      {  "prim": "address",
                         "annots": [
                           "%from_"
                         ]
                      },
                      {  "prim": "list",
                         "args": [
                           {  "prim": "pair",
                              "args": [
                                {  "prim": "address",
                                   "annots": [
                                     "%to_"
                                   ]
                                },
                                {  "prim": "pair",
                                   "args": [
                                     {  "prim": "nat",
                                        "annots": [
                                          "%token_id"
                                        ]
                                     },
                                     {  "prim": "nat",
                                        "annots": [
                                          "%amount"
                                        ]
                                     }
                                   ]
                                }
                              ]
                           }
                         ]
                         ,
                         "annots": [
                           "%txs"
                         ]
                      }
                    ]
                 }
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "8"  }
               ]
            },
            {  "prim": "CONS"  },
            {  "prim": "TRANSFER_TOKENS"  },
            {  "prim": "CONS"  },
            {  "prim": "ITER",
               "args": [
                 [  {  "prim": "CONS"  }  ]
               ]
            },
            {  "prim": "DIP",
               "args": [
                 {  "int": "1"  },
                 [  {  "prim": "DIG",
                       "args": [
                         {  "int": "16"  }
                       ]
                 },
                 {  "prim": "DROP",
                    "args": [
                      {  "int": "1"  }
                    ]
                 }  ]
               ]
            },
            {  "prim": "DUG",
               "args": [
                 {  "int": "16"  }
               ]
            },
            {  "prim": "NIL",
               "args": [
                 {  "prim": "operation"  }
               ]
            },
            {  "prim": "NIL",
               "args": [
                 {  "prim": "operation"  }
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "19"  }
               ]
            },
            {  "prim": "ITER",
               "args": [
                 [  {  "prim": "CONS"  }  ]
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "13"  }
               ]
            },
            {  "prim": "CONTRACT",
               "args": [
                 {  "prim": "list",
                    "args": [
                      {  "prim": "pair",
                         "args": [
                           {  "prim": "address"  },
                           {  "prim": "list",
                              "args": [
                                {  "prim": "pair",
                                   "args": [
                                     {  "prim": "address"  },
                                     {  "prim": "pair",
                                        "args": [
                                          {  "prim": "nat"  },
                                          {  "prim": "nat"  }
                                        ]
                                     }
                                   ]
                                }
                              ]
                           }
                         ]
                      }
                    ]
                 }
               ]
               ,
               "annots": [
                 "%transfer"
               ]
            },
            {  "prim": "IF_NONE",
               "args": [
                 [  {  "prim": "PUSH",
                       "args": [
                         {  "prim": "string"  },
                         {  "string": "transfer"  }
                       ]
                 },
                 {  "prim": "PUSH",
                    "args": [
                      {  "prim": "string"  },
                      {  "string": "ENTRY_NOT_FOUND"  }
                    ]
                 },
                 {  "prim": "PAIR"  },
                 {  "prim": "FAILWITH"  }  ],
                 [    ]
               ]
            },
            {  "prim": "PUSH",
               "args": [
                 {  "prim": "mutez"  },
                 {  "int": "0"  }
               ]
            },
            {  "prim": "NIL",
               "args": [
                 {  "prim": "pair",
                    "args": [
                      {  "prim": "address",
                         "annots": [
                           "%from_"
                         ]
                      },
                      {  "prim": "list",
                         "args": [
                           {  "prim": "pair",
                              "args": [
                                {  "prim": "address",
                                   "annots": [
                                     "%to_"
                                   ]
                                },
                                {  "prim": "pair",
                                   "args": [
                                     {  "prim": "nat",
                                        "annots": [
                                          "%token_id"
                                        ]
                                     },
                                     {  "prim": "nat",
                                        "annots": [
                                          "%amount"
                                        ]
                                     }
                                   ]
                                }
                              ]
                           }
                         ]
                         ,
                         "annots": [
                           "%txs"
                         ]
                      }
                    ]
                 }
               ]
            },
            {  "prim": "DUP",
               "args": [
                 {  "int": "6"  }
               ]
            },
            {  "prim": "CONS"  },
            {  "prim": "TRANSFER_TOKENS"  },
            {  "prim": "CONS"  },
            {  "prim": "ITER",
               "args": [
                 [  {  "prim": "CONS"  }  ]
               ]
            },
            {  "prim": "DIP",
               "args": [
                 {  "int": "1"  },
                 [  {  "prim": "DIG",
                       "args": [
                         {  "int": "16"  }
                       ]
                 },
                 {  "prim": "DROP",
                    "args": [
                      {  "int": "1"  }
                    ]
                 }  ]
               ]
            },
            {  "prim": "DUG",
               "args": [
                 {  "int": "16"  }
               ]
            },
            {  "prim": "DROP",
               "args": [
                 {  "int": "4"  }
               ]
            },
            {  "prim": "PUSH",
               "args": [
                 {  "prim": "int"  },
                 {  "int": "1"  }
               ]
            },
            {  "prim": "DIP",
               "args": [
                 {  "int": "1"  },
                 [  {  "prim": "DIG",
                       "args": [
                         {  "int": "11"  }
                       ]
                 },
                 {  "prim": "DROP",
                    "args": [
                      {  "int": "1"  }
                    ]
                 }  ]
               ]
            },
            {  "prim": "DUG",
               "args": [
                 {  "int": "11"  }
               ]
            }  ],
            [  {  "prim": "PUSH",
                  "args": [
                    {  "prim": "string"  },
                    {  "string": "INVALID_STATE"  }
                  ]
            },
            {  "prim": "FAILWITH"  }  ]
          ]
       },
       {  "prim": "DROP",
          "args": [
            {  "int": "1"  }
          ]
       },
       {  "prim": "PAIR",
          "args": [
            {  "int": "11"  }
          ]
       },
       {  "prim": "DIG",
          "args": [
            {  "int": "1"  }
          ]
       },
       {  "prim": "PAIR"  }  ]
     ]
  }  ];

export const getStorage = (a_contractToken, a_token_id, a_quantity, a_debtor, a_creditor, b_contractToken, b_token_id, b_quantity, b_debtor, b_creditor) => {
  return {  "prim": "Pair",
            "args": [
              {  "string": a_contractToken  },
              {  "prim": "Pair",
                 "args": [
                   {"int": a_token_id.toString()},
                   {  "prim": "Pair",
                      "args": [
                        {"int": a_quantity.toString()},
                        {  "prim": "Pair",
                           "args": [
                             {  "string": a_debtor  },
                             {  "prim": "Pair",
                                "args": [
                                  {  "string": a_creditor  },
                                  {  "prim": "Pair",
                                     "args": [
                                       {  "string": b_contractToken  },
                                       {  "prim": "Pair",
                                          "args": [
                                            {"int": b_token_id.toString()},
                                            {  "prim": "Pair",
                                               "args": [
                                                 {"int": b_quantity.toString()},
                                                 {  "prim": "Pair",
                                                    "args": [
                                                      {  "string": b_debtor  },
                                                      {  "prim": "Pair",
                                                         "args": [
                                                           {  "string": b_creditor  },
                                                           {  "int": "0"  }
                                                         ]
                                                      }
                                                    ]
                                                 }
                                               ]
                                            }
                                          ]
                                       }
                                     ]
                                  }
                                ]
                             }
                           ]
                        }
                      ]
                   }
                 ]
              }
            ]
         };
  }
